package com.hai.service;

import com.hai.entity.HighGasDiscountOilPrice;
import com.hai.model.GasPayPriceModel;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

public interface HighGasDiscountOilPriceService {

    /**
     * 编辑
     */
    void editGasDiscountOilPrice(HighGasDiscountOilPrice highGasDiscountOilPrice);

    /**
     * 删除
     * @param id
     */
    void delete(Long id);

    /**
     * 根据id查询
     * @param id
     * @return
     */
    HighGasDiscountOilPrice getDetail(Long id);

    /**
     * 根据油号 查询
     * @param oilNo
     * @return
     */
    HighGasDiscountOilPrice getDetailByOilNo(String oilNo);

    /**
     * 根据油号名称 查询
     * @param oilNoName
     * @return
     */
    HighGasDiscountOilPrice getDetailByOilNoName(String oilNoName);

    /**
     * 查询列表
     * @param map
     * @return
     */
    List<HighGasDiscountOilPrice> getList(Map<String,Object> map);

    /**
     * 计算加油优惠、支付价格
     * @param oilingPrice  加油价格
     * @param goodsId      油站id
     * @param oilNo        油品
     * @param isTyAgent    是否代理商模式
     * @return
     */
    GasPayPriceModel oilPriceDiscountCompute(BigDecimal oilingPrice, Long goodsId, String oilNo, Boolean isTyAgent) throws Exception;

}
